package events;

import communication.Comm;
import java.io.IOException;
import view.GraphicUI;

/**
 * Vlakno starajici se o prichozi packety.
 *
 * @author Michael
 */
public class ListenNXT implements Runnable {

    private Comm comm;
    private GraphicUI gui;
    private boolean run;

    
    /**
     * Konstruktor vlakna.
     * @param c Komunikacni trida.
     * @param g Graficke rozhrani.
     */
    public ListenNXT(Comm c, GraphicUI g) {
        comm = c;
        gui = g;
        run = true;
    }
    
    public void requestStop() {
        run = false;
    }

    /**
     * Spousti vlakno. Ceka na prichozi packet (String) a ten pak precte do
     * logu.
     */
    @Override
    public void run() {
        try {
            while(run) {
                gui.logEvents(comm.getPacket());
            }
        } catch(IOException io) {
            // nothing to do
        }
    }

}
