package imageProcessing;

import java.util.ArrayList;

/**
 * Trida fungujici jako tvar v soustave souradnic.
 * Tvar je popsan useckamy z tridy "Line".
 *
 * @author Michael
 */
public class Shape {
    
    private ArrayList<Line> cary;
    
    /**
     * Konstruktor.
     * @param prvniCara Prvni usecka popisujici tvar
     */
    public Shape(Line prvniCara) {
        cary = new ArrayList<>();
        cary.add(prvniCara);
    }
    
    /**
     * Vrati usecky popisujici tvar.
     * @return Seznam usecek
     */
    public ArrayList<Line> getLines() {
        return cary;
    }
    
    /**
     * Prideli usecku tvaru, pokud je pridavana usecka spojena s nejakou jiz
     * popisujici tento tvar.
     * @param l Testovana usecka
     * @return True pokud je cara zahrnuta do tvaru
     */
    public boolean addLine(Line l) {
        for(Line cara : cary) {
            if(cara.isConnected(l)) {
                if(!cara.isSame(l)) cary.add(l);
                return true;
            }
        }
        return false;
    }
    
}
