package view;

import communication.Comm;
import java.awt.Color;
import java.awt.FlowLayout;
import java.io.IOException;
import javax.swing.JLabel;
import events.KeyboardListener;
import events.ListenNXT;
import webcam.Cam;

/**
 * Hlavni trida programu a graficke rozhrani.
 *
 * @author Michael
 */
public class GraphicUI extends javax.swing.JFrame {

    private Cam cam;
    private Comm comm;
    private KeyboardListener kl;
    private ListenNXT listenNXT;
    private Thread tlistenNXT; //vlakno pro tridu "listenNXT"
    
    private String textEvents; //text v logu
    
    /**
     * Creates new form Main
     */
    public GraphicUI() {
        initComponents();
        
        comm = new Comm();
        kl = new KeyboardListener(this, comm);
        listenNXT = new ListenNXT(comm, this);
        tlistenNXT = new Thread(listenNXT);
        
        textEvents = "";
        cam = new Cam(this);
        jPanelCam.setLayout(new FlowLayout());
        jPanelCam.add(cam.getWebcamPanel());
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jbCam = new javax.swing.JButton();
        jbDisconnect = new javax.swing.JButton();
        jbConnect = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        zalozka1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtaCommands = new javax.swing.JTextArea();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jArrow0 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jArrow3 = new javax.swing.JLabel();
        jArrow1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jArrow2 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        zalozka2 = new javax.swing.JPanel();
        jPanelCam = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtaShapes = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("PC to NXT");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setName("frame"); // NOI18N
        setResizable(false);

        jbCam.setText("Start cam");
        jbCam.setPreferredSize(new java.awt.Dimension(80, 100));
        jbCam.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbCamActionPerformed(evt);
            }
        });

        jbDisconnect.setText("Disconnect");
        jbDisconnect.setPreferredSize(new java.awt.Dimension(80, 100));
        jbDisconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbDisconnectActionPerformed(evt);
            }
        });

        jbConnect.setText("Connect");
        jbConnect.setPreferredSize(new java.awt.Dimension(80, 100));
        jbConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbConnectActionPerformed(evt);
            }
        });

        zalozka1.setLayout(new javax.swing.BoxLayout(zalozka1, javax.swing.BoxLayout.LINE_AXIS));

        jtaCommands.setColumns(10);
        jtaCommands.setRows(5);
        jScrollPane1.setViewportView(jtaCommands);

        zalozka1.add(jScrollPane1);

        jPanel2.setLayout(new java.awt.GridLayout());

        jLabel1.setForeground(java.awt.Color.gray);
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("UP");
        jPanel2.add(jLabel1);

        jPanel3.setLayout(new java.awt.GridLayout());

        jArrow0.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 50)); // NOI18N
        jArrow0.setForeground(java.awt.Color.gray);
        jArrow0.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jArrow0.setText("\u21E7");
        jPanel3.add(jArrow0);

        jPanel4.setLayout(new java.awt.GridLayout());

        jLabel2.setForeground(java.awt.Color.gray);
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("LEFT");
        jPanel4.add(jLabel2);

        jArrow3.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 50)); // NOI18N
        jArrow3.setForeground(java.awt.Color.gray);
        jArrow3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jArrow3.setText("\u21E6");
        jPanel4.add(jArrow3);

        jArrow1.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 50)); // NOI18N
        jArrow1.setForeground(java.awt.Color.gray);
        jArrow1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jArrow1.setText("\u21E8");
        jPanel4.add(jArrow1);

        jLabel3.setForeground(java.awt.Color.gray);
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel3.setText("RIGHT");
        jPanel4.add(jLabel3);

        jPanel5.setLayout(new java.awt.GridLayout());

        jArrow2.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 50)); // NOI18N
        jArrow2.setForeground(java.awt.Color.gray);
        jArrow2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jArrow2.setText("\u21E9");
        jPanel5.add(jArrow2);

        jPanel6.setLayout(new java.awt.GridLayout());

        jLabel4.setForeground(java.awt.Color.gray);
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("DOWN");
        jPanel6.add(jLabel4);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel6, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        zalozka1.add(jPanel1);

        jTabbedPane1.addTab("Key commands", zalozka1);

        jPanelCam.setBackground(new java.awt.Color(0, 0, 0));
        jPanelCam.setPreferredSize(new java.awt.Dimension(450, 360));

        javax.swing.GroupLayout jPanelCamLayout = new javax.swing.GroupLayout(jPanelCam);
        jPanelCam.setLayout(jPanelCamLayout);
        jPanelCamLayout.setHorizontalGroup(
            jPanelCamLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 450, Short.MAX_VALUE)
        );
        jPanelCamLayout.setVerticalGroup(
            jPanelCamLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 360, Short.MAX_VALUE)
        );

        jtaShapes.setColumns(10);
        jtaShapes.setRows(5);
        jScrollPane2.setViewportView(jtaShapes);

        javax.swing.GroupLayout zalozka2Layout = new javax.swing.GroupLayout(zalozka2);
        zalozka2.setLayout(zalozka2Layout);
        zalozka2Layout.setHorizontalGroup(
            zalozka2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(zalozka2Layout.createSequentialGroup()
                .addComponent(jPanelCam, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 177, Short.MAX_VALUE))
        );
        zalozka2Layout.setVerticalGroup(
            zalozka2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(zalozka2Layout.createSequentialGroup()
                .addGroup(zalozka2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelCam, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 360, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Cam", zalozka2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbConnect, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE)
                    .addComponent(jbCam, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbDisconnect, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 638, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 388, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbConnect, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbDisconnect, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jbCam, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Akce pro tlacitko "Connect".
     * @param evt 
     */
    private void jbConnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbConnectActionPerformed
        if(comm.connect()) {
            this.setFocusable(true);
            this.setFocusTraversalKeysEnabled(false);
            this.addKeyListener(kl);
            this.requestFocusInWindow();
            
            logEvents("Connected...");
            tlistenNXT.setDaemon(true);
            tlistenNXT.start();
        } else {
            logEvents("Connect err");
        }
    }//GEN-LAST:event_jbConnectActionPerformed

    /**
     * Akce pro tlacitko "Start cam".
     * @param evt 
     */
    private void jbCamActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbCamActionPerformed
        cam.start();
    }//GEN-LAST:event_jbCamActionPerformed

    /**
     * Akce pro tlacitko "Disconnect".
     * @param evt 
     */
    private void jbDisconnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbDisconnectActionPerformed
        if(cam.isConnected()) {
            cam.stop();
            logEvents("Cam shutdown");
        }
        if(comm.isConnected()) {
            try {
                tlistenNXT.sleep(1);
                listenNXT.requestStop();
                this.removeKeyListener(kl);
                comm.closeAll();
                
                logEvents("Disconnected...");
            } catch (IOException ex) {
                logEvents("Disconnection err");
            } catch (InterruptedException ex) {
                logEvents("Listen stop err");
            }
        }
    }//GEN-LAST:event_jbDisconnectActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraphicUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraphicUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraphicUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraphicUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GraphicUI().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jArrow0;
    private javax.swing.JLabel jArrow1;
    private javax.swing.JLabel jArrow2;
    private javax.swing.JLabel jArrow3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanelCam;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbCam;
    private javax.swing.JButton jbConnect;
    private javax.swing.JButton jbDisconnect;
    private javax.swing.JTextArea jtaCommands;
    private javax.swing.JTextArea jtaShapes;
    private javax.swing.JPanel zalozka1;
    private javax.swing.JPanel zalozka2;
    // End of variables declaration//GEN-END:variables

// public
    
    /**
     * Zaloguje veskere operace probehnute na strane PC.
     * @param msg Zprava k zalogovani
     */
    public void logEvents(String msg) {
        if(textEvents.length() > 200) {
            textEvents = textEvents.substring(msg.length());
        }

        textEvents = textEvents + "\n" + msg;
        jtaCommands.setText(textEvents);
    }
    
    /**
     * Zaloguje nalezene tvary v obrazku kamery.
     * @param msg Zprava k zalogovani
     */
    public void logShapes(String msg) {
        jtaShapes.setText(msg);
        jtaShapes.repaint();
    }
    
    /**
     * Vizualizace kliknuti. Prebarvuje sipky "lArrow", urceno pro kliknuti
     * na klavesnici.
     * @param arrowIndex Index sipky.
     * @param clicked True pro kliknuti.
     */
    public void setArrowClicked(int arrowIndex, boolean clicked) {
        JLabel jl = null;
        switch(arrowIndex) {
            case 0:
                jl = jArrow0;
                break;
            case 1:
                jl = jArrow1;
                break;
            case 2:
                jl = jArrow2;
                break;
            case 3:
                jl = jArrow3;
                break;
        }
        
        try {
            if(clicked) {
                jl.setForeground(Color.ORANGE);
            } else {
                jl.setForeground(Color.GRAY);
            }
            jl.repaint();
        } catch(Exception e) {
            //nothing to do
        }
    }
    
}
